﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
'Custom View class
#Event: ExampleEvent (Value As Int)
#Event: Example2Event (Value As Int, Test as String)
#Event: Resize (Width As Double, Height As Double)
#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
#DesignerProperty: Key: WebView, DisplayName: Webview use, FieldType: Boolean, DefaultValue: False, Description: Webview kullanısın.
#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
#DesignerProperty: Key: Ratio, DisplayName: Resimen boy oranı, FieldType: Int, DefaultValue: 1
#DesignerProperty: Key: PictureIndex, DisplayName: Seçiçli resim sırası, FieldType: Int, DefaultValue: 0
#DesignerProperty: Key: Real_img_Height, DisplayName: Orjinal resim yüksekliği, FieldType: int, DefaultValue: 0
#DesignerProperty: Key: Real_img_Width, DisplayName: Orijinal resim genişliği, FieldType: int, DefaultValue: 0

#DesignerProperty: Key: TextcolorT, DisplayName: Label test color Aktive, FieldType: Color, DefaultValue: 0xFFFF0000, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: TextcolorF, DisplayName: Label text color pasive, FieldType: Color, DefaultValue: 0xFF0000FF, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: BackcolorT, DisplayName: Label b.color Aktive, FieldType: Color, DefaultValue: 0x80008000, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: BackcolorF, DisplayName: Label b.color Pasive, FieldType: Color, DefaultValue: 0x7EFF0000, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: BackcolorN, DisplayName: Label b.color Normal, FieldType: Color, DefaultValue: 0x7FFFFF00, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: Bordercolor, DisplayName: Label Border color, FieldType: Color, DefaultValue: 0x7E00008B, Description: You can use the built-in color picker To find the color values.
#DesignerProperty: Key: Back, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
Sub Class_Globals
	'Type MyResim (Folder As String, Name As String, Picture As Image, Pic_Height As Int, Pic_Width As Int)
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private m As Map
	Private ScrollPaneX As ScrollPane
	Private imageViewX As ImageView
	Private Ratio As Double
	Private CMenu As ContextMenu
	Private Real_image_Height As Double
	Private Real_image_Width As Double
	Private PictureList As List
	Private SelectedIndex As Int
	Private Labels As List
	Private Label_Background_Color_T As Int
	Private Label_Background_Color_F As Int
	Private Label_Background_Color_N As Int
	Private Label_text_color_T As Int
	Private Label_text_color_F As Int
	Private Video As MediaPlayer
	Private Web As WebView
	Private Mform As Form
	Private MediaViewObj As JavaObject
	Private UseWeb As Boolean
End Sub



'<code>
'	Dim m As Map
'	m.Initialize
'	m.Put("Zoom in 25%",0.25)
'	m.Put("Zoom in 50%",0.5)
'	m.Put("Fit 100%",1)
'	m.Put("Zoom out 125%",1.25)
'	m.Put("Zoom out 150%",1.5)
'	m.Put("Zoom out 200%",2)
'	Resim1.Initialize(Mform1,"Resim",m)
'</code>
Public Sub Initialize2 (Callback As Object, EventName As String,sagtus As Map )
	'Log("Initialize2 ")
	mEventName = EventName
	mCallBack = Callback
	m=sagtus
	PictureList.Initialize
	PictureList.Clear
	Dim  a As B4XBitmap
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	'Log("Initialize ")
	mEventName = EventName
	mCallBack = Callback
	PictureList.Initialize
	PictureList.Clear
	Labels.Initialize
End Sub
Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	'Log("DesignerCreateView")
	Dim xui As XUI
	mBase = Base
	Ratio=Props.Get("Ratio")
	SelectedIndex=Props.Get("PictureIndex")
	Label_Background_Color_T=xui.PaintOrColorToColor(Props.Get("BackcolorT"))
	Label_Background_Color_F= xui.PaintOrColorToColor(Props.Get("BackcolorF"))
	Label_Background_Color_N= xui.PaintOrColorToColor(Props.Get("BackcolorN"))
	Label_text_color_T=xui.PaintOrColorToColor(Props.Get("TextcolorT"))
	Label_text_color_F=xui.PaintOrColorToColor(Props.Get("TextcolorF"))
	UseWeb= Props.Get("WebView")
	Labels.Initialize
	Dim mm As Map
	mm.Initialize
	mm.Clear
	mm.Put("Zoom in 25%",0.25)
	mm.Put("Zoom in 50%",0.5)
	mm.Put("Fit 100%",1)
	mm.Put("Zoom out 125%",1.25)
	mm.Put("Zoom out 150%",1.5)
	mm.Put("Zoom out 200%",2)
	
	ScrollPaneX.Initialize("ScrollPaneX")
	mBase.AddNode(ScrollPaneX,0,0,mBase.Width,mBase.Height)
	imageViewX.Initialize("imageViewX")
	Dim panex As Pane
	panex=ScrollPaneX.InnerNode
	panex.AddNode(imageViewX,0,0,mBase.Width,mBase.Height)
	Web.Initialize("Web")
	panex.AddNode(Web,0,0,-1,-1)
	Web.Visible=False
	'panex.AddNode(Video,0,0,-1,-1)
	Dim jo As JavaObject = imageViewX
	Dim e As Object = jo.CreateEventFromUI("javafx.event.EventHandler", "scroll", Null)
	jo.RunMethod("setOnScroll", Array(e))
	setZoomRate(mm)
End Sub


Private Sub Base_Resize (Width As Double, Height As Double)
	'Log("Base_Resize ")
	ScrollPaneX.PrefWidth=Width
	ScrollPaneX.PrefHeight=Height
	ScrollPaneX.Pannable=True
	Redraw
	Log("burası kıralabilir")
	
	CallSub3(mCallBack,mEventName & "_Resize",Width,Height)
End Sub

Public Sub ClearAll
	PictureList.Clear
	If Web.Visible Then
		Web.LoadHtml("")
		Web.Visible=False
	End If
	imageViewX.Visible=False
	RefreshLabel(False)
End Sub

Private Sub Redraw

	If UseWeb  And imageViewX.Visible=False Then
	
		ScrollPaneX.InnerNode.PrefHeight=ScrollPaneX.PrefHeight*Ratio
		ScrollPaneX.InnerNode.PrefWidth=ScrollPaneX.PrefWidth*Ratio
		Web.PrefHeight=ScrollPaneX.PrefHeight*Ratio
		Web.PrefWidth=ScrollPaneX.PrefWidth*Ratio

	 
	Else If UseWeb=False And imageViewX.Visible=False Then
			
		ScrollPaneX.InnerNode.PrefHeight=ScrollPaneX.PrefHeight*Ratio
		ScrollPaneX.InnerNode.PrefWidth=ScrollPaneX.PrefWidth*Ratio
		Real_image_Width=ScrollPaneX.InnerNode.PrefWidth
		Real_image_Height=ScrollPaneX.InnerNode.PrefHeight
		If MediaViewObj.IsInitialized  Then
			Video.Pause
			MediaViewObj.RunMethod("setX",Array(0.0))
			MediaViewObj.RunMethod("setY",Array(0.0))
			MediaViewObj.RunMethod("setFitWidth",Array(Real_image_Width))
			MediaViewObj.RunMethod("setFitHeight",Array(Real_image_Height))
			Log("Redraw play")
			Video.Play
		End If
	Else
		Dim p As Pane
		p=ScrollPaneX.InnerNode
		p.PrefHeight=Floor(Real_image_Height*Ratio)
		p.PrefWidth=Floor(Real_image_Width*Ratio)
		imageViewX.PrefWidth=Floor(Real_image_Width*Ratio)
		imageViewX.PrefHeight=Floor(Real_image_Height*Ratio)
		For i=0 To p.NumberOfNodes-1
			Dim xx  As Node
			If p.GetNode(i) Is ImageView Then
				'-----
			Else
				xx=p.GetNode(i)
				xx.PrefHeight=ScrollPaneX.PrefHeight
				xx.PrefWidth=ScrollPaneX.PrefWidth
			End If
				
		Next
	End If
	
End Sub


Public Sub GetBase As Pane
	Return mBase
End Sub

Public Sub addPicture(Folder As String, Filename As String) As Boolean
	'imageViewX.MouseCursor=fx.Cursors.WAIT
	Dim xDir,xName As String
	
	If Filename.Trim="" Then
		xDir=File.GetFileParent(Folder)
		xName=File.GetName(Folder)
	Else if Folder.Trim="" Then
		xDir=File.GetFileParent(Filename)
		xName=File.GetName(Filename)
	Else
		xDir=Folder
		xName=Filename
	End If
	
	ScrollPaneX.MouseCursor=fx.Cursors.WAIT
	If File.Exists(xDir,xName) Then
		Dim x As MyResim
		x.Initialize
		'x.Name=rr
		x.Folder=xDir
		x.Name=xName
		If x.Name.ToUpperCase.EndsWith(".PNG") Or x.Name.ToUpperCase.EndsWith(".JPG") Or x.Name.ToUpperCase.EndsWith(".BMP") Then
			'If x.Name.ToUpperCase.EndsWith(".PNG") Or x.Name.ToUpperCase.EndsWith(".JPG") Or x.Name.ToUpperCase.EndsWith(".BMP") Then
			Dim bmp As Image
			bmp.Initialize2(File.OpenInput(xDir,xName))
			'bmp.Initialize2(File.OpenInput(rr,""))
			x.Pic_Width=bmp.Width
			x.Pic_Height=bmp.Height
			x.Picture=bmp
		Else
			x.Pic_Width=ScrollPaneX.PrefWidth
			x.Pic_Height=ScrollPaneX.PrefHeight
			'x.Name=File.GetUri(xDir,xName)
		End If
		PictureList.Add(x)
		RefreshLabel(False)
		ScrollPaneX.MouseCursor=fx.Cursors.DEFAULT
		Return True
	Else if xDir.Trim="AssetsDir" Then
		Try
			Dim x As MyResim
			x.Initialize
			
			x.Folder=xDir
			x.Name=xName
			If x.Name.ToUpperCase.EndsWith(".PNG") Or x.Name.ToUpperCase.EndsWith(".JPG") Or x.Name.ToUpperCase.EndsWith(".BMP") Then
				'If x.Name.ToUpperCase.EndsWith(".PNG") Or x.Name.ToUpperCase.EndsWith(".JPG") Or x.Name.ToUpperCase.EndsWith(".BMP") Then
				Dim bmp As Image
				'bmp.Initialize2(File.OpenInput(rr,""))
				bmp.Initialize2(File.OpenInput(xDir,xName))
				x.Pic_Width=bmp.Width
				x.Pic_Height=bmp.Height
				x.Picture=bmp
				
			Else
				x.Pic_Width=ScrollPaneX.PrefWidth
				x.Pic_Height=ScrollPaneX.PrefHeight
				x.Name=File.GetUri(xDir,xName)
			End If
			
			PictureList.Add(x)
			RefreshLabel(False)
			ScrollPaneX.MouseCursor=fx.Cursors.DEFAULT
			Return True
		Catch
			Log("************RESIM*********************")
			Log(" resim dir assette doyası bulunamadı")
			Log("*********************************")
			RefreshLabel(False)
			ScrollPaneX.MouseCursor=fx.Cursors.DEFAULT
			Return False
		End Try
	Else
		Log(File.DirAssets)
		Log("************RESIM*********************")
		Log(" resim doyası bulunamadı")
		Log("*********************************")
		RefreshLabel(False)
		ScrollPaneX.MouseCursor=fx.Cursors.DEFAULT
		Return False
	End If
	
End Sub

Private Sub RefreshLabel(ShowPlayer As Boolean)
	
	If Labels.Size<> PictureList.Size Then
		For i=0 To Labels.Size-1
			Dim L As Label
			L=Labels.Get(i)
			L.RemoveNodeFromParent
		Next
	End If
	
	For i=0 To Labels.Size-1
		Dim L As Label=Labels.Get(i)
		L.RemoveNodeFromParent
	Next
	Labels.Clear
	
	For i=0 To PictureList.Size-1
		Dim L As Label
		L.Initialize("MYLBL")
		mBase.AddNode(L,10+i*40,10,30,30)
		L.Text=i+1
		L.Tag=i
		L.Alignment="CENTER"
		L.TextColor=fx.Colors.From32Bit(Label_text_color_F)
		Dim x As MyResim=PictureList.Get(i)
		L.TooltipText=x.Name
		If x.Name.ToUpperCase.EndsWith(".PNG") Or x.Name.ToUpperCase.EndsWith(".JPG") Or x.Name.ToUpperCase.EndsWith(".BMP") Then
			CSSUtils.SetBorder(L,0,fx.Colors.From32Bit(Label_Background_Color_N),15)
		Else
			CSSUtils.SetBorder(L,0,fx.Colors.From32Bit(Label_Background_Color_N),0)
		End If
		If  x.Name.ToUpperCase.EndsWith(".AVI") Or x.Name.ToUpperCase.EndsWith(".MPG") Or x.Name.ToUpperCase.EndsWith(".MP4") Or x.Name.ToUpperCase.EndsWith(".MPEG") Then
			
		End If
			
		CSSUtils.SetBackgroundColor(L,fx.Colors.From32Bit(Label_Background_Color_N))
		L.MouseCursor=fx.Cursors.HAND
			
		Labels.Add(L)
	Next
	
	
	
	
	
End Sub


Private Sub MYLBL_MouseClicked (EventData As MouseEvent)
	'Log(PictureList.Size&"--"&Labels.Size)
	For i=0 To PictureList.Size-1
		Dim L As Label=Labels.Get(i)
		L.TextColor=fx.Colors.From32Bit(Label_text_color_F)
		CSSUtils.SetBackgroundColor(L,fx.Colors.From32Bit(Label_Background_Color_N))
	Next
		
	If EventData.ClickCount>1 Then
		Dim lbl As Label
		lbl= Sender
		If IsNumber( lbl.Text.Trim) Then
			lbl.TextColor=fx.Colors.From32Bit(Label_text_color_T)
			CSSUtils.SetBackgroundColor(lbl,fx.Colors.From32Bit(Label_Background_Color_T))
			PictureSelect(lbl.Tag)
		Else
			If lbl.Text.Trim=">" Then
				
				Video.Stop
				Video.Play
				Log("Video PLAY")
			End If
			If lbl.Text.Trim="=" Then
				
				Video.Pause
				Video.Pause
				Log("Video PAUSE")
			End If
		End If
	End If
End Sub

'
'Private Sub Refresh
'	
'	Redraw
'End Sub


Public Sub SetPictureIndex(index As Int)
	PictureSelect(index)
End Sub

Public Sub GetPictureIndex As Int
	Return SelectedIndex
End Sub


Private Sub PictureSelect(index As Int)
	If index>=PictureList.Size Then
		Log("************RESIM*********************")
		Log(" seçilen resim kodu, mevcut listeden fazla")
		Log("*********************************")
		Return
	End If
	
	PlaserBuronSil
	
	Dim x As MyResim
	x.Initialize
	x=PictureList.Get(index)
	Web.LoadHtml("")
	If x.Picture.IsInitialized Then
		
		Real_image_Height=x.Pic_Height
		Real_image_Width=x.Pic_Width
		Ratio=1
		imageViewX.SetImage(x.Picture)
		imageViewX.Visible=True
		Web.Visible=False
		If MediaViewObj.IsInitialized Then
			Dim MVN As Node = MediaViewObj
			MVN.RemoveNodeFromParent
			Video.Stop
		End If
		
	Else if x.Name.ToUpperCase.Trim.EndsWith(".PDF") Then
	
		'Else if x.Name.ToUpperCase.Trim.EndsWith(".PDF") Then
		If Mform.IsInitialized=False Then
			Log("************RESIM*********************")
			Log("Ana form tanımlanmamış, aşağıdaki gibi yap")
			Log("Resim1.setMform(MainForm)")
			Log("*********************************")
			Return
		End If
		If x.Name.ToUpperCase.Trim.EndsWith(".PDF")  Then
			If File.Exists(x.Folder,x.Name) Then
				If fx.Msgbox2(Mform,File.GetUri(x.Folder,x.Name)&CRLF& "doyasını harici bir program ile açmak istiyor musunuz?", "DİKKAT", "Evet, aç", "İptal", "Hayır",fx.MSGBOX_CONFIRMATION) = fx.DialogResponse.POSITIVE Then
					fx.ShowExternalDocument(File.GetUri(x.Folder,x.Name))
				Else
					fx.Msgbox(Mform,File.GetUri(x.Folder,x.Name)&CRLF&"açma işlemi iptal edildi","DİKKAT")
				End If
			Else
				fx.Msgbox(Mform,File.GetUri(x.Folder,x.Name)&CRLF&"dosyası yerinde bulunmadı","DİKKAT")
			End If
			
		End If
		imageViewX.Visible=False
		Web.Visible=False
		
	Else
		If UseWeb Then
			
			Real_image_Height=ScrollPaneX.PrefHeight
			Real_image_Width=ScrollPaneX.PrefWidth
			Ratio=1
			imageViewX.Visible=False
			Web.Visible=True
			Load(x.Folder.Trim,x.Name.Trim)
			
		Else
			PlaserBuronEkle
			imageViewX.Visible=False
			Real_image_Height=ScrollPaneX.PrefHeight
			Real_image_Width=ScrollPaneX.PrefWidth
			Ratio=1
			If MediaViewObj.IsInitialized Then
				Dim MVN As Node = MediaViewObj
				MVN.RemoveNodeFromParent
				
			End If
			Video.Initialize("Video",File.GetUri(x.Folder,x.Name))
			MediaViewObj.InitializeNewInstance("javafx.scene.media.MediaView",Array As Object(Video))
			Dim panex As Pane
			panex=ScrollPaneX.InnerNode
			panex.AddNode(MediaViewObj,0,0,-1,-1)
			
		End If
	End If
	SelectedIndex=index
	
	Redraw
End Sub

Private Sub Load(dir As String, Filename As String)
	If Web.IsInitialized Then
		Dim sb As StringBuilder
		sb.Initialize
		sb.Append("<video width='100%' height='90%' controls>")
		sb.Append("<source src='"&File.GetUri(dir,Filename) &"' Type='video/mp4'/>")
		sb.Append("</video>")
		Web.LoadHtml(sb.ToString)
	End If
	
End Sub

'<code>
'	Dim m As Map
'	m.Initialize
'	m.Put("Zoom in 25%",0.25)
'	m.Put("Zoom in 50%",0.5)
'	m.Put("Fit 100%",1)
'	m.Put("Zoom out 125%",1.25)
'	m.Put("Zoom out 150%",1.5)
'	m.Put("Zoom out 200%",2)
'   Resim1.setZoomRate(m)
'</code>
Public Sub setZoomRate(maplist As Map) As Boolean
	m.Initialize
	m.Clear
	m.Put("[Fit in page]",0.009999)
	m.Put("[Zoom +20%]",0.0099)
	m.Put("[Zoom -20%]",-0.0099)
	For i = 0 To maplist.Size - 1
		m.put(maplist.GetKeyAt(i),maplist.GetValueAt(i))
	Next
	CMenu.Initialize("CM")
	For i = 0 To m.Size - 1
		Dim MItem As MenuItem
		MItem.Initialize(m.GetKeyAt(i),"CM")
		CMenu.MenuItems.Add(MItem)
		If IsNumber(m.GetValueAt(i))=False Then
			Log("************RESIM*********************")
			Log("Zoom oranı sayı olarak tanımlanmamış")
			Log("Lütfen tekrar yükleme yapınız")
			Log("*********************************")
			Return False
		End If
	Next
	ScrollPaneX.ContextMenu=CMenu
	Return True
End Sub
Public Sub getZoomRate As Map
	Return m
End Sub

Private Sub PlaserBuronSil()
	If Labels.Size>PictureList.Size Then
		For i=PictureList.Size To Labels.Size-1
			Dim L As Label
			L=Labels.Get(i)
			L.RemoveNodeFromParent
		Next
	End If
End Sub

Private Sub PlaserBuronEkle()
	Dim i As Int = PictureList.Size
		
	Dim L As Label
	L.Initialize("MYLBL")
	mBase.AddNode(L,10+i*40,10,30,30)
	L.Text=">"
	L.Tag=i
	L.Alignment="CENTER"
	L.TextColor=fx.Colors.From32Bit(Label_text_color_F)
		
	L.TooltipText="PLAY"
	CSSUtils.SetBorder(L,0,fx.Colors.From32Bit(Label_Background_Color_N),15)
	CSSUtils.SetBackgroundColor(L,fx.Colors.From32Bit(Label_Background_Color_N))
	L.MouseCursor=fx.Cursors.HAND
	Labels.Add(L)
		
	i=i+1
	Dim L As Label
	L.Initialize("MYLBL")
	mBase.AddNode(L,10+i*40,10,30,30)
	L.Text="="
	L.Tag=i
	L.Alignment="CENTER"
	L.TextColor=fx.Colors.From32Bit(Label_text_color_F)
		
	L.TooltipText="STOP"
	CSSUtils.SetBorder(L,0,fx.Colors.From32Bit(Label_Background_Color_N),15)
	CSSUtils.SetBackgroundColor(L,fx.Colors.From32Bit(Label_Background_Color_N))
	L.MouseCursor=fx.Cursors.HAND
	Labels.Add(L)
		

End Sub

'<code>
' Resim1.setColor(fx.Colors.Green)
'</code>
Public Sub setColor(bcolor As Object)
	CSSUtils.SetBackgroundColor(ScrollPaneX,bcolor)
	CSSUtils.SetBackgroundColor(imageViewX,bcolor)
End Sub

Private Sub CM_Action
	Dim MItem As MenuItem = Sender
	If m.GetDefault(MItem.Text,1)=0.0099 Then
		Ratio = Ratio*1.2
	else if m.GetDefault(MItem.Text,1)=0-0.0099 Then
		Ratio = Ratio*0.8
	else if m.GetDefault(MItem.Text,1)=0.009999 Then
		If Real_image_Height/ScrollPaneX.PrefHeight>Real_image_Width/ScrollPaneX.PrefWidth Then
			Ratio = ScrollPaneX.PrefHeight/Real_image_Height
		Else
			Ratio = ScrollPaneX.PrefWidth/Real_image_Width
		End If
	Else
		Ratio = m.GetDefault(MItem.Text,1)
	End If
	If Ratio<=0.05 Then  Ratio=0.05
	If Ratio>=5 Then Ratio=5
	Redraw
End Sub

Public Sub setTag(Tag As String)
	mBase.Tag = Tag
End Sub
Public Sub getTag As String
	Return mBase.Tag
End Sub

Public Sub setVisible(Visible As Boolean)
	mBase.Visible = Visible
End Sub
Public Sub getVisible As Boolean
	Return mBase.Visible
End Sub

Public Sub setLabel_Background_Color_T(color As Int)
	Label_Background_Color_T=color
	RefreshLabel(False)
End Sub
Public Sub getLabel_Background_Color_T As Int
	Return Label_Background_Color_T
End Sub

Public Sub setLabel_Background_Color_N(color As Int)
	Label_Background_Color_N=color
	RefreshLabel(False)
End Sub
Public Sub getLabel_Background_Color_N As Int
	Return Label_Background_Color_N
End Sub
Public Sub setLabel_Background_Color_F(color As Int)
	Label_Background_Color_F=color
	RefreshLabel(False)
End Sub
Public Sub getLabel_Background_Color_F As Int
	Return Label_Background_Color_F
End Sub
Public Sub setEnabled(Enabled As Boolean)
	mBase.Enabled = Enabled
	For Each v As Node In mBase.GetAllViewsRecursive
		v.Enabled = Enabled
	Next
End Sub
Public Sub getEnabled As Boolean
	Return mBase.Enabled
End Sub

Public Sub setMform(frm As Form)
	Mform=frm
End Sub
Public Sub getMform As Form
	Return Mform
End Sub

Public Sub setWebViewUse(Enabled As Boolean)
	UseWeb=Enabled
End Sub
Public Sub getWebViewUse As Boolean
	Return UseWeb
End Sub

